package forge.program;

/**
 * A constant boolean expression: true or false.
 *
 * @author Greg Dennis (gdennis@mit.edu)
 */
public final class BooleanLiteral extends ForgeLiteral {

	private final boolean value;
	private final BooleanDomain type;
	
	BooleanLiteral(BooleanDomain type, boolean value) {
		super(type.program(), Boolean.toString(value));
		this.type = type;
		this.value = value;
	}
	
	public BooleanDomain type() {
		return type;
	}

	public boolean value() {
		return value;
	}
	
}
