package forge.program;

/**
 * A set of atoms disjoint from all other classes.
 * A singleton union of classes.
 *
 * @author Greg Dennis (gdennis@mit.edu)
 */
public abstract class ForgeDomain extends TypeFactory.DomainType
		implements ForgeExpression.Leaf {
	
	public static enum Kind {INSTANCE, INTEGER, BOOLEAN}
	
	private final String name;
	private final Kind kind;
	
	ForgeDomain(TypeFactory factory, String name, Kind kind) {
		super(factory);
		if (name == null || kind == null) throw new NullPointerException();
		this.name = name;
		this.kind = kind;
	}
	
	public final String name() {
		return name;
	}
	
	public final Kind kind() {
		return kind;
	}

	public final String toString() {
		return name;
	}
	
}