package forge.program;

import edu.mit.csail.sdg.annotations.Returns;

/**
 * A singleton constant
 *
 * @author Greg Dennis (gdennis@mit.edu)
 */
public abstract class ForgeLiteral extends AbstractExpression
		implements ForgeExpression.Leaf {
	
	private final String name;

	ForgeLiteral(ForgeProgram program, String name) {
		super(program);
		if (name == null) throw new NullPointerException("name");
		this.name = name;
	}
	
	public abstract ForgeDomain type();
	
	public final <T> T accept(ExpressionVisitor<T> visitor) {
		return visitor.fullVisit(this);
	}

	@Returns("this.name")
	public final String name() {
		return name;
	}

	public final String toString() {
		return name;
	}
	
}
