package forge.program;

import edu.mit.csail.sdg.annotations.Effects;
import edu.mit.csail.sdg.annotations.Modifies;
import edu.mit.csail.sdg.annotations.Returns;

/**
 * A constant integer expression.
 *
 * @author Greg Dennis (gdennis@mit.edu)
 */
public final class IntegerLiteral extends ForgeLiteral {

	private final int value;
	private final IntegerDomain type;
	
	@Effects("this.(IntegerLiteral@type) = type && this.(IntegerLiteral@value) = value")
	@Modifies("this.type, this.value")
	IntegerLiteral(IntegerDomain type, int value) {
		super(type.program(), Integer.toString(value));
		this.type = type;
		this.value = value;
	}
	
	@Returns("this.type")
	public IntegerDomain type() {
		return type;
	}
	
	@Returns("this.value")
	public int value() {
		return value;
	}
}
