package forge.program;

import edu.mit.csail.sdg.util.collections.SDGCollections;
import edu.mit.csail.sdg.util.collections.UniqueList;

/**
 * A Forge local variable.
 *
 * @author Greg Dennis (gdennis@mit.edu)
 */
public final class LocalVariable extends ForgeVariable implements LocalDecls {
	
	private UniqueList<LocalVariable> thisLocal = null;

	LocalVariable(String name, ForgeType type) {
		super(name, type);
	}

	public boolean isGlobal() {
		return false;
	}

	public LocalDecls and(LocalVariable local) {
		return new MultiDecls(this, local);
	}

	public UniqueList<LocalVariable> locals() {
		if (thisLocal == null) {
			thisLocal = SDGCollections.singletonUniqueList(this);
		}
		return thisLocal;
	}

}
