package forge.program;

/**
 * Refers to the old value of a modified variable in an assume statement.
 * 
 * @author Greg Dennis (gdennis@mit.edu)
 */
public final class OldExpression extends AbstractExpression {

	private final ForgeVariable var;
	
	OldExpression(ForgeVariable var) {
		super(var.program());
		this.var = var;
	}
	
	public ForgeVariable variable() {
		return var;
	}

	@Override
	public ForgeType type() {
		return var.type();
	}
	
	@Override 
	public String toString() {
		return "old(" + var + ")";
	}

	public <T> T accept(ExpressionVisitor<T> visitor) {
		return visitor.fullVisit(this);
	}

}
