package forge.solve;

import edu.mit.csail.sdg.annotations.Returns;
import forge.program.BooleanDomain;

/**
 * A constant boolean expression: true or false.
 *
 * @author Greg Dennis (gdennis@mit.edu)
 */
public final class BooleanAtom extends ForgeAtom {

	private final boolean value;
	private final BooleanDomain type;
	
	BooleanAtom(ConstantFactory factory, boolean value, BooleanDomain type) {
		super(factory, Boolean.toString(value));
		this.value = value;
		this.type = type;
	}
	
	/* inherits specification */
	public BooleanDomain type() {
		return type;
	}

	@Returns("this.value")
	public boolean value() {
		return value;
	}
	
	/* inherits specification */
	public BooleanAtom bool() {
		return this;
	}

	/* inherits specification */
	public IntegerAtom sum() {
		return factory.intAtom(0);
	}
}
