package forge.solve;

import edu.mit.csail.sdg.annotations.Returns;
import forge.program.ForgeDomain;

/**
 * A singleton constant
 *
 * @author Greg Dennis (gdennis@mit.edu)
 */
public abstract class ForgeAtom extends ConstantFactory.AtomConst {
	
	private final String name;

	ForgeAtom(ConstantFactory factory, String name) {
		super(factory);
		if (name == null) throw new NullPointerException("name");
		this.name = name;
	}
	
	/* inherits specification */
	public abstract ForgeDomain type();
	
	@Returns("this.name")
	public final String name() {
		return name;
	}

	public final String toString() {
		return name;
	}
}