package forge.solve;

import kodkod.engine.Evaluator;
import forge.program.ForgeExpression;
import forge.translate.ExprTranslator;

/**
 * Evaluates Forge expressions as constants
 *
 * @author Greg Dennis (gdennis@mit.edu)
 */
final class ForgeEvaluator {
		
	final Evaluator kkEval;
	final ForgeBounds bounds;
	final ExprTranslator transl;
	
	ForgeEvaluator(Evaluator kkEval, ForgeBounds bounds, ExprTranslator transl) {
		this.kkEval = kkEval;
		this.bounds = bounds;
		this.transl = transl;
	}
	
	ForgeConstant evaluate(ForgeExpression expr) {
		return bounds.makeConstant(kkEval.evaluate(transl.toExpr(expr)));
	}
	
	boolean evaluateBool(ForgeExpression expr) {
		return kkEval.evaluate(transl.toForm(expr));
	}
	
	int evaluateInt(ForgeExpression expr) {
		return kkEval.evaluate(transl.toInt(expr));
	}
}
