package forge.solve;

import forge.program.InstanceDomain;

/**
 * An atom in an Atom class.
 * 
 * @author Greg Dennis (gdennis@mit.edu)
 */
public final class InstanceAtom extends ForgeAtom {
	
	private final InstanceDomain type;

	InstanceAtom(ConstantFactory factory, String name, InstanceDomain type) {
		super(factory, name);
		this.type = type;
	}
	
	/* inherits specification */
	public InstanceDomain type() {
		return type;
	}
	
	/* inherits specification */
	public BooleanAtom bool() {
		return factory.boolAtom(false);
	}

	/* inherits specification */
	public IntegerAtom sum() {
		return factory.intAtom(0);
	}
}