package forge.solve;

import edu.mit.csail.sdg.annotations.Returns;
import forge.program.IntegerDomain;

/**
 * A constant boolean expression: true or false.
 *
 * @author Greg Dennis (gdennis@mit.edu)
 */
public final class IntegerAtom extends ForgeAtom {

	private final int value;
//	private final IntegerRepresentation intRep;
//	private final BitString bits;
	private final IntegerDomain type;
	
	IntegerAtom(ConstantFactory factory, int value, IntegerDomain type) {
		super(factory, Integer.toString(value));
		this.value = value;
//		intRep = factory.intRep();
//		this.bits = intRep.fromInt(value).unmodifiableView();
		this.type = type;
	}
	
	/* inherits specification */
	public IntegerDomain type() {
		return type;
	}

	@Returns("this.value")
	public int value() {
		return value;
	}
	
	/* inherits specification */
	public BooleanAtom bool() {
		return factory.boolAtom(false);
	}
	
	/* inherits specification */
	public IntegerAtom sum() {
		return this;
	}
//	
//	public BooleanAtom lessThan(IntegerAtom i) {
//		return factory.boolAtom(intRep.lt(bits, i.bits));
//	}
//	
//	public BooleanAtom greaterThan(IntegerAtom i) {
//		return factory.boolAtom(intRep.gt(bits, i.bits));
//	}
//	
//	public IntegerAtom neg() {
//		BitString result = new BitString(bits);
//		intRep.negate(result);
//		return intAtom(result);
//	}
//	
//	public IntegerAtom plus(IntegerAtom i) {
//		BitString result = new BitString(bits);
//		intRep.add(result, i.bits);
//		return intAtom(result);
//	}
//	
//	public IntegerAtom minus(IntegerAtom i) {
//		BitString result = new BitString(bits);
//		intRep.subtract(result, i.bits);
//		return intAtom(result);
//	}
//	
//	public IntegerAtom times(IntegerAtom i) {
//		BitString result = new BitString(bits);
//		intRep.multiply(result, i.bits);
//		return intAtom(result);
//	}
//	
//	public IntegerAtom divide(IntegerAtom i) {
//		BitString result = new BitString(bits);
//		intRep.divide(result, i.bits);
//		return intAtom(result);
//	}
//	
//	public IntegerAtom modulo(IntegerAtom i) {
//		BitString result = new BitString(bits);
//		intRep.modulo(result, i.bits);
//		return intAtom(result);
//	}
//	
//	public IntegerAtom and(IntegerAtom i) {
//		BitString result = new BitString(bits);
//		result.and(i.bits);
//		return intAtom(result);
//	}
//	
//	public IntegerAtom or(IntegerAtom i) {
//		BitString result = new BitString(bits);
//		result.or(i.bits);
//		return intAtom(result);
//	}
//	
//	public IntegerAtom xor(IntegerAtom i) {
//		BitString result = new BitString(bits);
//		result.xor(i.bits);
//		return intAtom(result);
//	}
//	
//	public IntegerAtom shiftLeft(IntegerAtom i) {
//		BitString result = new BitString(bits);
//		intRep.shl(result, i.bits);
//		return intAtom(result);
//	}
//	
//	public IntegerAtom shiftRight(IntegerAtom i) {
//		BitString result = new BitString(bits);
//		intRep.shr(result, i.bits);
//		return intAtom(result);
//	}
//	
//	public IntegerAtom unsignedShiftRight(IntegerAtom i) {
//		BitString result = new BitString(bits);
//		intRep.ushr(result, i.bits);
//		return intAtom(result);
//	}
//	
//	private IntegerAtom intAtom(BitString bits) {
//		return factory.intAtom(intRep.toInt(bits));
//	}
	
}
