package forge.translate;

import kodkod.ast.Expression;
import kodkod.ast.Formula;
import edu.mit.csail.sdg.util.collections.Pair;
import forge.program.ForgeExpression.Modifiable;
import forge.translate.SymbolicExecutor.AssignHook;
import forge.translate.SymbolicExecutor.BranchHook;
import forge.translate.SymbolicExecutor.CreateHook;
import forge.translate.SymbolicExecutor.SpecHook;

/**
 * The strategy for symbolic execution.
 *
 * @author Greg Dennis (gdennis@mit.edu)
 */
public interface SEStrategy {

	public Formula execute(AssignHook hook);
	
	public Formula execute(CreateHook hook);
	
	public Formula execute(SpecHook hook);
	
	public Pair<Formula,Formula> merge(BranchHook hook, Modifiable mod,
			Expression thenExpr, Expression elseExpr);
}
