package forge.util;

import java.util.List;
import java.util.Set;

import forge.solve.ForgeReporter;

/**
 * A reporter that prints out basic information to the standard out noting
 * which phase of the translation it is in.
 *
 * @author Greg Dennis (gdennis@mit.edu)
 */
public final class SystemOutReporter extends ForgeReporter {

	public static final ForgeReporter REPORTER = new SystemOutReporter();
	
	private SystemOutReporter() {}

	@Override
	public void flattening(Object circuit) {
		System.out.println("flattening");
	}

	@Override
	public void solvingAnalysis() {
		System.out.println("solving analysis");
	}

	@Override
	public void transformingProcedure() {
		System.out.println("transforming procedure");
	}

	@Override
	public void generatingSBP() {
		System.out.println("generating SBP");
	}

	@Override
	public void optimizingBoundsAndFormula() {
		System.out.println("optimizing bounds and formula");
	}

	@Override
	public void detectedSymmetries(Set<?> parts) {
		System.out.println("detected symmetries");
	}

	@Override
	public void detectingSymmetries(Object bounds) {
		System.out.println("detecting symmetries");
	}

	@Override
	public void buildingAnalysis() {
		System.out.println("building analysis");
	}

	@Override
	public void translatingToBoolean(Object formula, Object bounds) {
		System.out.println("translating to boolean");
	}

	@Override
	public void translatingToKodkod() {
		System.out.println("translating to Kodkod");
	}

	@Override
	public void translatingToCNF(Object circuit) {
		System.out.println("translating to CNF");
	}

	@Override
	public void solvingCNF(int primaryVars, int vars, int clauses) {
		System.out.println("solving CNF: primaryVars = " + primaryVars + " ; vars = " + vars + " ; clauses = " + clauses);
	}

	@Override
	public void skolemizing(Object decl, Object skolem, List<?> context) {
		System.out.println("skolemizing");
	}
	
}
