/*! \addtogroup Annotations Annotations 
 * This module defines several Squander-specific specification annotations (in addition to existing JFSL annotations). 
 * @{ 
 */
package edu.mit.csail.sdg.squander.annotations;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Specifies creation of new objects. 
 * 
 * @author Aleksandar Milicevic
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.METHOD)
@Documented
public @interface Fresh {

    FreshObjects[] value();
    
}
/*! @} */
