/*! \addtogroup Annotations Annotations 
 * This module defines several Squander-specific specification annotations (in addition to existing JFSL annotations). 
 * @{ 
 */
package edu.mit.csail.sdg.squander.annotations;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * Specifies creation of new objects of a given class.
 * 
 * @author Aleksandar Milicevic
 */
@Retention(RetentionPolicy.RUNTIME)
@Documented
public @interface FreshObjects {

    /** class of the object to be created */
    Class<?> cls();
    /** type parameters of <code>cls</code> (if any) */
    Class<?>[] typeParams() default {};
    /** number of instances to be created */
    int num() default 1;
    
}
/*! @} */
