/*! \addtogroup Serialization Serialization 
 * This module is in charge of serializing and deserializing objects (i.e. it provides abstraction and concretization functions for several types of classes). 
 * @{ 
 */
package edu.mit.csail.sdg.squander.serializer;

import java.lang.reflect.Field;

/**
 * An interface for listening to events generated by the Serializer.
 * 
 * @see Serializer
 * @author drayside
 * 
 */
public interface HeapListener {

    public void newObject(Object obj);
    public void visitPrimitive(Object obj);
    public void visitRefField(Field field, Object source, Object value);
    public void visitIntField(Field field, Object source, int value);
    public void visitBooleanField(Field field, Object obj, boolean value);
    public void visitArrayIntField(Object sourceArray, int index, int value);
    public void visitArrayRefField(Object sourceArray, int index, Object value);
    public void visitArrayLength(Object sourceArray, int length);

}
/*! @} */
