package tmp;

import java.util.Arrays;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;

import kodkod.ast.Formula;
import kodkod.ast.Relation;
import kodkod.engine.Evaluator;
import kodkod.engine.Solution;
import kodkod.engine.Solver;
import kodkod.instance.Bounds;
import kodkod.instance.TupleFactory;
import kodkod.instance.Universe;
import kodkod.util.nodes.PrettyPrinter;

public class Nums {

    public static void main(String[] args) {
        Collection<Object> atoms = new LinkedList<Object>();
        int bw = 4; 
//        int min = - (1 << (bw-1));
//        int max = -min - 1;
//        for (int i = min; i <= max; i++) atoms.add(i);
        atoms.addAll(Arrays.asList("s1,s2,s3,r1,r2,r3".split(",")));
        Relation ss = Relation.unary("s");
        Relation rr = Relation.unary("r");
        
        Universe universe = new Universe(atoms);
        TupleFactory factory = universe.factory();
        Bounds bounds = new Bounds(universe);
//        for (int i = min; i <= max; i++) bounds.boundExactly(i, factory.setOf(i));
        bounds.bound(ss, factory.setOf("s1", "s2", "s3"));
        bounds.bound(rr, factory.setOf("r1", "r2", "r3"));
        
        Formula formula = ss.count().toExpression().eq(rr.count().plus(rr.count()).toExpression()); //ss.count().eq(rr.count().plus(rr.count()));
        
        Solver s = new Solver();
        s.options().setBitwidth(bw);
        System.out.println(PrettyPrinter.print(formula, 2));
        System.out.println(bounds);

        Iterator<Solution> it = s.solveAll(formula, bounds);
        while (it.hasNext()) {
            Solution sol = it.next();
            if (sol.instance() == null)
                break;
            Evaluator ev = new Evaluator(sol.instance(), s.options());
            System.out.println("====================================");
            System.out.println("s = " + ev.evaluate(ss));
            System.out.println("r = " + ev.evaluate(rr));
        }
    }
    
}
